#include <bits/stdc++.h>
 
using namespace std;
 
int main ()
{
    int n, a, b, o, ab;
    int p=0;
    string kg;
    cin>>n;
    cin>>o>>a>>b>>ab;
    int m[n][4];
    for(int i=0; i<n; i++){
        for(int j=0; j<4; j++){
            m[i][j]=0;
        }
    }
    int n[n], b[n];
    for(int i=0; i<n; i++){
        int j = 0;
        cin>>kg>>j;
        if(kg == "O") {
            if(o>=j) {
                m[i][0]=j;
                o=o-j;
            } 
            else{
                cout<<"nemoguce";
                p=1;
                return 0;
                }
        }
       else if(kg == "A"){
           if(a>=j){
               m[i][1]=j;
               a=a-j;
           }
           else {
               m[i][1]=a;
               j=j-a;
               if(o>=j) {
                m[i][0]=j;
                o=o-j;
            } 
                else {
                cout<<"nemoguce";
                p=1;
                return 0;
                }
           }
       }
       else if(kg == "B"){
           if(b>=j){
               m[i][2]=j;
               b=b-j;
           }
           else {
               m[i][2]=b;
               j=j-b;
               if(o>=j) {
                m[i][0]=j;
                o=o-j;
            } 
                else {
                cout<<"nemoguce";
                p=1;
                return 0;
                }
           }
       }
       else if(kg == "AB") {
           n[i]=1;
           b[i]=j;
       }
       else {
           n[i] = 0;
           b[i] = 0;
       }
 
    }
    if(p != 1){
        for(int i=0; i<n; i++){
            int j;
            j = b[i];
            if(n[i] == 1) {
                if(ab>=j){
                    m[i][3]=j;
                    ab=ab-j;
                }
                else {
                    m[i][3]=ab;
                    j=j-ab;
                    if(b>=j){
                        m[i][2]=j;
                        b=b-j;
                    }
                    else{
                        m[i][2]=b;
                        j=j-b;
                        if(a>=j){
                            m[i][1]=j;
                            a=a-j;
                        }
                        else {
                            m[i][1]=a;
                            j=j-a;
                            if(o>=j) {
                                m[i][0]=j;
                                o=o-j;
                            } 
                            else {
                                cout<<"nemoguce";
                                p=1;
                                return 0;
                            }
                        }
                    }
                }
            }
        }
    }
    if(p != 1) {
        cout<<"moguce"<<endl;
        for(int i=0; i<n; i++){
            for(int j=0; j<4; j++){
                cout<<m[i][j]<<" ";
            }
            cout<<endl;
        }
    }
 
    return 0;
}